using System;
using System.Xml;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.Configuration;
using System.Web.Security;
using Logicweb.WebCtls;

namespace lgwapp.common.login
{
	/// <summary>
	/// Summary description for Login.
	/// </summary>
	public class home : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label errMsg;
		protected System.Web.UI.WebControls.TextBox username;
		protected System.Web.UI.WebControls.TextBox password;
		protected System.Web.UI.HtmlControls.HtmlInputHidden retryCount;
		protected System.Web.UI.HtmlControls.HtmlInputHidden winLogin;
		protected System.Web.UI.WebControls.Panel loginZone;
		private string strUserId = "";
		private string strUser = null;
		private string strPass = null;
		protected string strFailCode = "N/A";
		bool bLoginSuccessed = false;
		bool bToWinLoginPage = false;

		private void Page_Load(object sender, System.EventArgs e)
		{
			bool bFormAuthOnly = false;

			if(Session["FormLoginOnly"]!=null && Convert.ToString(Session["FormLoginOnly"])=="Y") bFormAuthOnly = true;
			else if(winLogin.Value != null && winLogin.Value.Equals("form")) bFormAuthOnly = true;
			if(bFormAuthOnly) winLogin.Value = "form";

			SqlConnection cnn = new SqlConnection(Logicweb.Data.GetDatabaseConnectionString(1));
			try
			{
				cnn.Open();
				if(bFormAuthOnly==false)
				{
					SqlCommand cmdInternalIP = new SqlCommand("SELECT [dbo].[lwfnIsInternalIP]('" 
						+ Request.ServerVariables["REMOTE_HOST"] + "')", cnn);
					if(Convert.ToInt32(cmdInternalIP.ExecuteScalar())==1) bToWinLoginPage = true;
				}
				if(bToWinLoginPage==false)
				{
					strUser = Request.Params["username"];
					strPass = Request.Params["password"];
					username.Attributes.Add("onkeyup", "return returnKey(event);");
					password.Attributes.Add("onkeyup", "return returnKey(event);");
					if(strUser==null || strPass==null || strUser=="" || strPass=="") return;

					int nCount = Convert.ToInt32(retryCount.Value) + 1;
					retryCount.Value = nCount.ToString();
					if(nCount>3)
					{
						loginZone.Visible = false;
						errMsg.Text = "<br>Too many tries.<br><br>Please contact your system administrator.";
					}
					else doLogin(cnn);
				}
			}
			catch(Exception ex)
			{
				errMsg.Text = ex.Message + "<br><br>";
				strFailCode = "E";
			}
			finally
			{
				cnn.Close();
			}
			
			if(bLoginSuccessed)
			{
				Server.Transfer("chkBrowser.aspx?failCode="+strFailCode);
			}
			else if(bToWinLoginPage)
			{
				FormsAuthentication.SetAuthCookie("0", false);
				Response.Redirect("WinLogin.aspx?SID="+DateTime.Now.Ticks.ToString());
				Response.End();
			}
		}

		private void doLogin(SqlConnection cnn)
		{
			if(CheckLogin(cnn))
			{
				try
				{
					FormsAuthentication.SetAuthCookie(strUserId, false);
					bLoginSuccessed = true;
				}
				catch(Exception ex)
				{
					errMsg.Text = ex.Message;
				}
			}
		}

		private bool CheckLogin(SqlConnection cnn)
		{
			bool bRetValue = false;
			try
			{
				SqlCommand cmd = new SqlCommand("lwspCheckLoginByForm", cnn);
				cmd.CommandType = CommandType.StoredProcedure;

				SqlParameter p = new SqlParameter("@retValue", SqlDbType.BigInt);
				p.Direction = ParameterDirection.Output;
				cmd.Parameters.Add(p);

				p = new SqlParameter("@p_username", SqlDbType.VarChar, 100);
				p.Direction = ParameterDirection.Input;
				p.Value = strUser;
				cmd.Parameters.Add(p);

				p = new SqlParameter("@p_password", SqlDbType.VarChar, 20);
				p.Direction = ParameterDirection.Input;
				p.Value = strPass;
				cmd.Parameters.Add(p);
				cmd.ExecuteNonQuery();
				long nValue = Convert.ToInt64(cmd.Parameters[0].Value);
				if(nValue>0)
				{
					bRetValue = true;
					strUserId = Convert.ToString(nValue);
				}
				else if(nValue==0)
				{
					errMsg.Text = "Invalid password. Please try again.<br><br>";
					strFailCode = "P";
				}
				else
				{
					errMsg.Text = "Invalid login. Please try again.<br><br>";
					strFailCode = "U";
				}
			}
			catch(Exception ex)
			{
				errMsg.Text = ex.Message + "<br><br>";
				strFailCode = "E";
			}
			return bRetValue;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
