/*******************************************************************
 *   Database Functions (V3.0)
 *   Designed for SQL Server 2000
 *   10/12/2005
 *   Copyright(C) Logicweb Solutions
 *******************************************************************/

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnEncryptPassword]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnEncryptPassword]'
drop function [dbo].[lwfnEncryptPassword]
end
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnCheckPassword]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnCheckPassword]'
drop function [dbo].[lwfnCheckPassword]
end
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnInitCap]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnInitCap]'
drop function [dbo].[lwfnInitCap]
end
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnSearchCondition]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnSearchCondition]'
drop function [dbo].[lwfnSearchCondition]
end
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnIsInternalIP]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnIsInternalIP]'
drop function [dbo].[lwfnIsInternalIP]
end
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnWinLoginUserId]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnWinLoginUserId]'
drop function [dbo].[lwfnWinLoginUserId]
end
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnSortedPermKeyList]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnSortedPermKeyList]'
drop function [dbo].[lwfnSortedPermKeyList]
end
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[lwfnPermHtmlName]') and xtype in (N'FN', N'IF', N'TF'))
begin
print 'drop function [dbo].[lwfnPermHtmlName]'
drop function [dbo].[lwfnPermHtmlName]
end
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

print 'CREATE FUNCTION [dbo].[lwfnEncryptPassword]'
GO
CREATE FUNCTION [dbo].[lwfnEncryptPassword]
(
@passStr VARCHAR(50)
)
RETURNS varbinary(255)
BEGIN
	return pwdencrypt(@passStr)
END
GO

print 'CREATE FUNCTION [dbo].[lwfnCheckPassword]'
GO
CREATE FUNCTION [dbo].[lwfnCheckPassword]
(
	@userLgwId BIGINT,
	@passInput VARCHAR(50),
	@passSaved VARBINARY(255)
)
RETURNS bit
BEGIN
	return pwdcompare(convert(varchar,@userLgwId)+@passInput,@passSaved)
END
GO

print 'CREATE FUNCTION [dbo].[lwfnInitCap]'
GO
CREATE FUNCTION [dbo].[lwfnInitCap] (@str varchar(255) ) 
RETURNS varchar(255)
as
BEGIN
DECLARE @i int, @c char(1),@result varchar(255)
SET @result=LOWER(@str)
SET @i=2
SET @result=STUFF(@result,1,1,UPPER(SUBSTRING(@str,1,1)))
WHILE @i<=LEN(@str)
	BEGIN
	SET @c=SUBSTRING(@str,@i,1)
	IF (@c=' ') OR (@c=';') OR (@c=':') OR (@c='!') OR (@c='?') OR (@c=',') OR (@c='.') OR (@c='_')
		IF @i<LEN(@str)
			BEGIN
			SET @i=@i+1
			SET @result=STUFF(@result,@i,1,UPPER(SUBSTRING(@str,@i,1)))
			END
	SET @i=@i+1
	END
RETURN  @result
END
GO

print 'CREATE FUNCTION [dbo].[lwfnSearchCondition]'
GO
CREATE FUNCTION [dbo].[lwfnSearchCondition]
(
@field varchar(50),
@operator varchar(20),
@value varchar(200)
)
RETURNS varchar(300) AS  
BEGIN 
IF(@field=null OR @field='') RETURN NULL
IF(@operator='null')
	RETURN @field+' is null'
ELSE IF(@operator='not-null')
	RETURN @field+' is not null'
ELSE IF(@value is null OR @value='')
	RETURN @field+' is null'
ELSE IF(@operator='eq')
	RETURN @field+'='''+replace(@value,'''','''''')+''''
ELSE IF(@operator='start-with')
	RETURN @field+' like '''+replace(@value,'''','''''')+'%'''
ELSE IF(@operator='like')
	RETURN @field+' like ''%'+replace(@value,'''','''''')+'%'''
ELSE IF(@operator='on')
	RETURN 'convert(varchar(12),'+@field+',101)=convert(varchar(12),convert(datetime,'''+@value+'''),101)'
ELSE IF(@operator='on-or-before')
	RETURN @field+'<dateadd(d,1,convert(datetime,'''+@value+'''))'
ELSE IF(@operator='on-or-after')
	RETURN @field+'>=convert(datetime,'''+@value+''')'
RETURN NULL
END
GO

print 'CREATE FUNCTION [dbo].[lwfnIsInternalIP]'
GO

CREATE FUNCTION [dbo].[lwfnIsInternalIP]
(
	@ipAddr varchar(100)
)
RETURNS int AS  
BEGIN 
IF(isNull(@ipAddr,'')='') RETURN 0
IF(@ipAddr='127.0.0.1') RETURN 1
IF(LEFT(@ipAddr,5)='10.0.') RETURN 1
IF(LEFT(@ipAddr,8)='192.168.') RETURN 1
RETURN 0
END
GO

print 'CREATE FUNCTION [dbo].[lwfnWinLoginUserId]'
GO
CREATE FUNCTION [dbo].[lwfnWinLoginUserId]
(
	@winLogin varchar(100)
)
RETURNS int AS  
BEGIN
DECLARE @numB BIGINT
SELECT @numB=count(*) FROM lgwUsers WHERE winLogin=@winLogin
IF(@numB<>1) RETURN -@numB
SELECT @numB=[user_id] FROM lgwUsers WHERE winLogin=@winLogin
RETURN @numB
END
GO

print 'CREATE FUNCTION [dbo].[lwfnPermHtmlName]'
GO
CREATE FUNCTION [dbo].[lwfnPermHtmlName]
(
	@permName VARCHAR(50),
	@permLevel int
)
RETURNS VARCHAR(300) AS 
BEGIN 
	IF(@permLevel=1) RETURN '<B>' + @permName + '</B>'
	ELSE IF(@permLevel=2) RETURN '&nbsp;&nbsp;&nbsp;' + @permName
	ELSE IF(@permLevel=3) RETURN '&nbsp;&nbsp;&nbsp;- -&nbsp;' + @permName
	RETURN '- - - -' + @permName
END
GO

print 'CREATE FUNCTION [dbo].[lwfnSortedPermKeyList]'
GO
CREATE FUNCTION [dbo].[lwfnSortedPermKeyList]()
RETURNS @tbl TABLE (id bigint,orders int,glevel int) AS 
BEGIN 
DECLARE @grpId1  bigint
DECLARE @grpId2  bigint
DECLARE @grpId3  bigint
DECLARE @orders  int
SET @orders = 0
DECLARE c1 CURSOR FOR SELECT id FROM lgwPermKeys WHERE parent_id IS NULL ORDER BY name
OPEN c1
FETCH NEXT FROM c1 INTO @grpId1
WHILE (@@FETCH_STATUS = 0)
	BEGIN
	SET @orders = @orders + 1
	INSERT @tbl(id,orders,glevel) VALUES (@grpId1,@orders,1) 
	DECLARE c2 CURSOR FOR SELECT id FROM lgwPermKeys WHERE parent_id=@grpId1 ORDER BY name
	OPEN c2
	FETCH NEXT FROM c2 INTO @grpId2
	WHILE (@@FETCH_STATUS = 0)
		BEGIN
		SET @orders = @orders + 1
		INSERT @tbl(id,orders,glevel) VALUES (@grpId2,@orders,2) 
		DECLARE c3 CURSOR FOR SELECT id FROM lgwPermKeys WHERE parent_id=@grpId2 ORDER BY name
		OPEN c3
		FETCH NEXT FROM c3 INTO @grpId3
		WHILE (@@FETCH_STATUS = 0)
			BEGIN
			SET @orders = @orders + 1
			INSERT @tbl(id,orders,glevel) VALUES (@grpId3,@orders,3) 
			FETCH NEXT FROM c3 INTO @grpId3
			END
		CLOSE c3
		DEALLOCATE c3
		FETCH NEXT FROM c2 INTO @grpId2
		END
	CLOSE c2
	DEALLOCATE c2
	FETCH NEXT FROM c1 INTO @grpId1
	END
CLOSE c1
DEALLOCATE c1
RETURN 
END
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO